unit Mumps; { Implement MUMPS functions }
            {MDB}
interface
uses   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
        Forms, Dialogs, StdCtrls, ExtCtrls;//, Grids;

Function SetPiece(Node: string; Delimiter: string; FirstPiece: integer; NewPieces: string): string;
  {set $piece(node, delimiter, firstpiece, lastpiece)=newpieces quit node}
Function SetPieces(Node: string; Delimiter: string; FirstPiece: integer; LastPiece: integer; NewPieces: string): string;
  {set $piece(node, delimiter, firstpiece, lastpiece)=newpieces quit node}
Function PieceLength(Node: string; Delimiter: string): integer;
  {quit $length(node,delimiter) }
Function GetPiece(Node: string; Delimiter: string; FirstPiece: integer): string;
  {quit $piece(node, delimiter, firstpiece, lastpiece)}
Function GetPieces(Node: string; Delimiter: string; FirstPiece: integer; LastPiece: integer): string;
  {quit $piece(node, delimiter, firstpiece, lastpiece)}
Function Translate(Node: string; Find: string; Replace: string): string;
  {quit $translate(node,find,replace)}
Function Find(Node: string; SubString: string): Integer;
  {quit $find(node,substring)}
Function LeftJustify(Node: string; SLength: Integer): string;
Function RightJustify(Node: string; SLength: Integer): string;
Function Extract(Node: string; Start, Stop: Integer): String;

implementation

{=======================================================================================}
Function Extract(Node: string; Start, Stop: Integer): String;
begin
  if Start < 1 then Start := 1;
  if Stop > Length(Node) then Stop := Length(Node);
  Result := Copy(Node, Start, Stop - Start + 1);
end;
{=======================================================================================}
Function LeftJustify(Node: string; SLength: Integer): string;
begin
  Result := '';
  Result := SetPiece(Result, ' ', SLength - Length(Node) + 1, Node);
end;
{=======================================================================================}
Function RightJustify(Node: string; SLength: Integer): string;
begin
  Result := SetPiece(Node, ' ', SLength - Length(Node) + 1, '');
end;
{=======================================================================================}
Function Find(Node: string; SubString: string): Integer;
begin
  Result := Pos(SubString, Node);
  if Result > 0 then Result := Result + Length(SubString);
end;
{=======================================================================================}
Function Translate(Node: string; Find: string; Replace: string): string;
var i,j: integer;
    s1,s2,s3: string;
begin
{}  for i := 1 to length(Find) do
{1---}begin
        s1 := copy(find,i,1);
        j := 1;
        s3 := Node;
        s2 := '';
        while j > 0 do
{2-------}begin
            j := pos(s1, s3);
            if j = 0
            then s2 := s2 + s3
            else
{3-----------}begin
                s2 := s2 + copy(s3,0,j - 1);
                if i <= length(Replace) then s2 := s2 + copy(replace,i,1);
                s3 := copy(s3,j+1,length(s3)-1);
{3-----------}end;
{2-------}end;
      Node := s2;
{1---}end;
   Result := Node;
end;
{=======================================================================================}

{=======================================================================================}
Function SetPiece(Node: string; Delimiter: string; FirstPiece: integer; NewPieces: string): string;
begin
 Result := SetPieces(Node, Delimiter, FirstPiece, FirstPiece, NewPieces);
end;
{=======================================================================================}

{=======================================================================================}
Function GetPiece(Node: string; Delimiter: string; FirstPiece: integer): string;
begin
 Result := GetPieces(Node, Delimiter, FirstPiece, FirstPiece);
end;
{=======================================================================================}

{=======================================================================================}
Function SetPieces(Node: string; Delimiter: string; FirstPiece: integer; LastPiece: integer; NewPieces: string): string;
var i: integer;
   rest: string;
Begin
if FirstPiece <= PieceLength(Node,Delimiter)
  then
    begin
      rest := GetPieces(node,Delimiter,(LastPiece+1),PieceLength(Node,Delimiter));
      if FirstPiece > 1 then
          Result := GetPieces(node,Delimiter,1,(FirstPiece-1)) + Delimiter + NewPieces;
      if FirstPiece = 1 then
          Result := NewPieces;
      if rest <> '' then
          Result := Result + Delimiter + rest;
    end
  else
    begin
      Result := Node;
      for i := PieceLength(Node,Delimiter) to FirstPiece - 1 do
        Result := Result + Delimiter;
      Result := Result + NewPieces;
    end;
End;
{=======================================================================================}

{=======================================================================================}
Function PieceLength(Node: string; Delimiter: string): integer;
var i,j: integer;
  begin
    i := 1;
    j := 0;
    while i > 0 do
      begin
        i := pos(Delimiter, node);
        node := copy(node,i+1,length(node)-1);
        j := j + 1;
      end;
  Result := j;
end;
{=======================================================================================}

{=======================================================================================}
Function GetPieces(Node: string; Delimiter: string; FirstPiece: integer; LastPiece: integer): string;
type
  pieces = array[0..100] of byte;
var
   i , numpcs: integer;
  s1 : string;
  p1, p2: pieces;
begin
i := 1;
numpcs := 0;
s1 := node;
Result := '';
p1[0] := 0;
p2[0] := 0;
while i > 0 do
  begin
    i := pos(Delimiter, s1);
    numpcs := numpcs + 1;
    p1[numpcs] := i;
    p2[numpcs] := i;
    if numpcs > 1 then p2[numpcs] := p2[numpcs] + p2[numpcs - 1];
    s1 := copy(s1,i+1,length(s1)-i);
  end;
p1[numpcs] := length(s1) + 1;
p2[numpcs] := length(s1) + p2[numpcs - 1] + 1;
if (FirstPiece > 0) and (FirstPiece <= LastPiece) then
  begin;
  if LastPiece > numpcs then LastPiece := numpcs;
  Result := copy(node,p2[FirstPiece - 1] + 1 , p2[LastPiece] - p2[FirstPiece - 1] - 1);
  end;
end;
{=======================================================================================}

end.
