{***************************************************************

 UNIT NAME: KeyboardHook.DLL
 PACKAGE: Mental Health
 WARNING:
 DATE CREATED: Sep, 2001
 SITE NAME: Salt Lake City Mental Health Informatics Section
 DEVELOPERS: Feldman
 DESCRIPTION:
 NOTE: This unit requires Mental Health patch 67, or greater, in
       order to run.

    Portions Copyright by Joe C. Hecht - All rights reserved.
    Used by permission.
    email: joehecht@code4sale.com

 HISTORY  :

 Required third-party Delphi components and libraries:


****************************************************************
 NOTES:
    Much of this unit is based on the work of Joe Hecht, who posted this
    code on the Internet as sample code to accomplish these tasks. He
    graciously granted permission for our using it, and modifying it for
    this project.

    Portions Copyright by Joe C. Hecht - All rights reserved.
    Used by permission.
    email: joehecht@code4sale.com
}

library YS_MHA_KH;

uses
  Windows,
  Messages,
  SysUtils,
  Dialogs;

{Define a record for recording and passing information process wide}
type
  PHookRec = ^THookRec;
  THookRec = packed record
    TheHookHandle: HHOOK;
    TheAppWinHandle: HWND;
    TheCtrlWinHandle: HWND;
    TheKeyCount: DWORD;
    IsStartKeyDown: Boolean;
  end;

var
  hObjHandle: THandle; {Variable for the file mapping object}
  lpHookRec: PHookRec; {Pointer to our hook record}
  AlertMode: Boolean = False;

procedure MapFileMemory(dwAllocSize: DWORD);
begin
 {Create a process wide memory mapped variable}
  hObjHandle := CreateFileMapping($FFFFFFFF,
    nil,
    PAGE_READWRITE,
    0,
    dwAllocSize,
    'HookRecMemBlock');
  if (hObjHandle = 0) then begin
    MessageBox(0,
      'Hook DLL',
      'Could not create file map object',
      MB_OK);
    exit;
  end;
 {Get a pointer to our process wide memory mapped variable}
  lpHookRec := MapViewOfFile(hObjHandle,
    FILE_MAP_WRITE,
    0,
    0,
    dwAllocSize);
  if (lpHookRec = nil) then begin
    CloseHandle(hObjHandle);
    MessageBox(0,
      'Hook DLL',
      'Could not map file',
      MB_OK);
    exit;
  end;
end;


procedure UnMapFileMemory;
begin
 {Delete our process wide memory mapped variable}
  if (lpHookRec <> nil) then begin
    UnMapViewOfFile(lpHookRec);
    lpHookRec := nil;
  end;
  if (hObjHandle > 0) then begin
    CloseHandle(hObjHandle);
    hObjHandle := 0;
  end;
end;


function GetHookRecPointer: pointer stdcall;
begin
 {Return a pointer to our process wide memory mapped variable}
  result := lpHookRec;
end;

{The function that actually processes the keystrokes for our hook}

function KeyBoardProc(Code: integer;
  wParam: integer;
  lParam: integer): integer; stdcall;
var
  KeyUp: bool;
 {Remove comments for additional functionability
  IsAltPressed : bool;
  IsCtrlPressed : bool;
  IsShiftPressed : bool;
 }
//  KeyName: array[0..100] of char;
//  KeyNameString: string;

begin //of KeyBoardProc function

//  Result := 0;

  {#Todo1 need to trap Ctrl-ESC}

  //if (wParam in [48..90]) then
  if (wParam in [$60..$69, //Keypad numerics
   $30..$5A, //Alpha-numerics
   $0D, //ENTER key
   $10, //right SHIFT key
   $A0, //Left SHIFT key
   $14 //CAPS LOCK key
   ]) then
  begin
//  if (Code < 0) then
//   {Call the next hook in the hook chain}
//    result :=
//      CallNextHookEx(lpHookRec^.TheHookHandle,
//      Code,
//      wParam,
//      lParam);
//    if (GetAsyncKeyState(VK_LWIN) < 0) then {up-key is down}
//    begin
//          ShowMessage('key is down');
//  keybd_event( VK_LWIN, MapvirtualKey( VK_LWIN, 0), 0, 0 );
//keybd_event( VK_LWIN, MapvirtualKey( VK_LWIN, 0), KEYEVENTF_KEYUP, 0 );

//    keybd_event(VK_HELP, 0, 0, 0);
//    keybd_event(VK_HELP, 0, KEYEVENTF_KEYUP, 0);

//    lpHookRec^.IsStartKeyDown := True;
//    result := -1;
   {Hooking the keyboard}

//    exit;
//    end
//    else
    Result := 0;
  end
  else
  begin
     {Is this a key up message?}
//    KeyUp := ((lParam and (1 shl 31)) <> 0);

//{if the Shift key pressed}
//    if ((GetKeyState(VK_SHIFT) and (1 shl 15)) <> 0) then begin
//      IsShiftPressed := TRUE;
//    end else begin
//      IsShiftPressed := FALSE;
//    end;

     {If KeyUp then increment the key count}
//    if (KeyUp <> FALSE) then begin
//      Inc(lpHookRec^.TheKeyCount);
//      keybd_event(VK_ESCAPE, 0, 0, 0);
//      keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
//    end;
//    keybd_event(VK_RETURN, 0, 0, 0);
//    keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
//    lpHookRec^.IsStartKeyDown := True;
//    if (GetAsyncKeyState(VK_LWIN) < 0) then {up-key is down}
//    begin
//          ShowMessage('key is down');

//  keybd_event( VK_LWIN, MapvirtualKey( VK_LWIN, 0), 0, 0 );
//keybd_event( VK_LWIN, MapvirtualKey( VK_LWIN, 0), KEYEVENTF_KEYUP, 0 );

   {Hooking the keyboard}

//    exit;
//    end;
     {Is this a key up message?}
    KeyUp := ((lParam and (1 shl 31)) <> 0);

     {If KeyUp then increment the key count}
    if (KeyUp <> FALSE) or (GetAsyncKeyState(VK_LWIN) < 0)
       or (GetAsyncKeyState(VK_RWIN) < 0)
    then //begin
      Inc(lpHookRec^.TheKeyCount);
//     keybd_event(VK_ESCAPE, 0, 0, 0);
//      keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
//    end;
    result := -1;
  end;

(*
  {Virtual key code to Key Name}
  GetKeyNameText({Message.} LParam, @KeyName, 100);

      //for debugging
  KeyNameString := string(KeyName);

  //List all keystrokes we want to trap
  if (KeyNameString = 'Left Windows') or
    (KeyNameString = 'Right Windows') or
    (KeyNameString = 'Ctrl') or
    (KeyNameString = 'Right Control') or
    (KeyNameString = 'Alt') or
    (KeyNameString = 'Right Alt') or
    (KeyNameString = 'Application') or
    (KeyNameString = 'Esc') or
    (KeyNameString = 'Left') or
    (KeyNameString = 'Right') or
    (KeyNameString = 'Up') or
    (KeyNameString = 'Down') or
    (KeyNameString = 'F1') or
    (KeyNameString = 'F2') or
    (KeyNameString = 'F3') or
    (KeyNameString = 'F4') or
    (KeyNameString = 'F5') or
    (KeyNameString = 'F6') or
    (KeyNameString = 'F7') or
    (KeyNameString = 'F8') or
    (KeyNameString = 'F9') or
    (KeyNameString = 'F10') or
    (KeyNameString = 'F11') or
    (KeyNameString = 'F12') or
    (KeyNameString = 'Tab') or
    (KeyNameString = 'Enter') // or //this is for Return key
//    (wParam in [32..255])
    { or
    (AlertMode and (string(KeyName) = 'LButton'))}

  then
  begin

    AlertMode := True; //Prohibited keystroke was detected.

    If lpHookRec^.IsStartKeyDown then
     begin
      lpHookRec^.IsStartKeyDown := False;
      keybd_event(VK_ESCAPE, 0, 0, 0);
      keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
//      result := -1;
//      exit;
     end;

    //Handle the Start key. Just toggle it off
    if (KeyNameString = 'Left Windows') or
      (KeyNameString = 'Right Windows')
      then
    begin
//+      keybd_event(VK_ESCAPE, 0, 0, 0);
//      keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
      lpHookRec^.IsStartKeyDown := True;
      result := -1;
      exit;
    end
    else
      lpHookRec^.IsStartKeyDown := False;


    //Handle the arrow keys. Just ignore them.
    if (KeyNameString = 'Left') or
      (KeyNameString = 'Right') or
      (KeyNameString = 'Up') or
      (KeyNameString = 'Down')
      then
    begin
      keybd_event(VK_ESCAPE, 0, 0, 0);
      keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
    end;

//?    else

//    begin

//      PostMessage(lpHookRec^.TheCtrlWinHandle, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
//    SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, 1, nil, 0);

//    end;

//    //Trigger the screensaver, which should be password-protected.
//    PostMessage(lpHookRec^.TheCtrlWinHandle, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
//
     {Is this a key up message?}
    KeyUp := ((lParam and (1 shl 31)) <> 0);

     {If KeyUp then increment the key count}
    if (KeyUp <> FALSE) then begin
      Inc(lpHookRec^.TheKeyCount);
      keybd_event(VK_ESCAPE, 0, 0, 0);
      keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
    end;

    //Ignore keystroke. This works only partially with the Start and Ctrl keys.
    result := -1;
//    exit;

//    //Trigger the screensaver, which should be password-protected.
//    PostMessage(lpHookRec^.TheCtrlWinHandle, WM_SYSCOMMAND, SC_SCREENSAVE, 0);

  end
  else

    if lpHookRec^.IsStartKeyDown then
    begin
//      keybd_event(VK_ESCAPE, 0, 0, 0);
//      keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
      result := -1;
      lpHookRec^.IsStartKeyDown := false;
      exit;
    end;


//     {Is this a key up message?}
//  KeyUp := ((lParam and (1 shl 31)) <> 0);
//
//     {If KeyUp then increment the key count}
//  if (KeyUp <> FALSE) then begin
//    Inc(lpHookRec^.TheKeyCount);
//        keybd_event(VK_ESCAPE, 0, 0, 0);
//        keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
//  end;

//  case Code of
//    HC_ACTION : begin
//     {We trap the keystrokes here}
//
//     {Is this a key up message?}
//      KeyUp := ((lParam AND (1 shl 31)) <> 0);
//
//    (*Remove comments for additional functionability
//     {Is the Alt key pressed}
//      if ((lParam AND (1 shl 29)) <> 0) then begin
//        IsAltPressed := TRUE;
//      end else begin
//        IsAltPressed := FALSE;
//      end;
//
//     {Is the Control key pressed}
//      if ((GetKeyState(VK_CONTROL) AND (1 shl 15)) <> 0) then begin
//        IsCtrlPressed := TRUE;
//      end else begin
//        IsCtrlPressed := FALSE;
//      end;
//
//     {if the Shift key pressed}
//      if ((GetKeyState(VK_SHIFT) AND (1 shl 15)) <> 0) then begin
//        IsShiftPressed := TRUE;
//      end else begin
//        IsShiftPressed := FALSE;
//      end;
//     *)
//
//     {If KeyUp then increment the key count}
//      if (KeyUp <> FALSE) then begin
//        Inc(lpHookRec^.TheKeyCount);
//      end;
//
//      case wParam of
//
//       {Was the enter key pressed?}
//        VK_RETURN : begin
//          {if KeyUp}
//           if (KeyUp <> FALSE) then begin
//            {Post a bogus message to the window control in our app}
//             PostMessage(lpHookRec^.TheCtrlWinHandle,
//                         WM_KEYDOWN,
//                         0,
//                         0);
//             PostMessage(lpHookRec^.TheCtrlWinHandle,
//                         WM_KEYUP,
//                         0,
//                         0);
//           end;
//          {If you wanted to swallow the keystroke then return -1}
//          {else if you want to allow the keystroke then return 0}
//           result := 0;
//           exit;
//         end; {VK_RETURN}
//
//       {If the left arrow key is pressed then lets play a joke!}
//        VK_LEFT : begin
//          {if KeyUp}
//           if (KeyUp <> FALSE) then begin
//            {Create a UpArrow keyboard event}
//             keybd_event(VK_RIGHT, 0, 0, 0);
//             keybd_event(VK_RIGHT, 0, KEYEVENTF_KEYUP, 0);
//           end;
//          {Swallow the keystroke}
//           result := -1;
//           exit;
//         end; {VK_LEFT}
//
//      end; {case wParam}
//     {Allow the keystroke}
//      result := 0;
//    end; {HC_ACTION}
//    HC_NOREMOVE : begin
//      {This is a keystroke message, but the keystroke message}
//      {has not been removed from the message queue, since an}
//      {application has called PeekMessage() specifying PM_NOREMOVE}
//      result := 0;
//      exit;
//    end;
//  end; {case code}
  if (Code < 0) then
   {Call the next hook in the hook chain}
    result :=
      CallNextHookEx(lpHookRec^.TheHookHandle,
      Code,
      wParam,
      lParam);
end;

procedure StartKeyBoardHook; stdcall;
begin
 {If we have a process wide memory variable}
 {and the hook has not already been set...}
  if ((lpHookRec <> nil) and
    (lpHookRec^.TheHookHandle = 0)) then begin
   {Set the hook and remember our hook handle}
    lpHookRec^.TheHookHandle := SetWindowsHookEx(WH_KEYBOARD,
      @KeyBoardProc,
      hInstance,
      0);
  end;
end;


procedure StopKeyBoardHook; stdcall;
begin
 {If we have a process wide memory variable}
 {and the hook has already been set...}
  if ((lpHookRec <> nil) and
    (lpHookRec^.TheHookHandle <> 0)) then begin
   {Remove our hook and clear our hook handle}
    if (UnHookWindowsHookEx(lpHookRec^.TheHookHandle) <> FALSE) then
    begin
      lpHookRec^.TheHookHandle := 0;
    end;
  end;
end;


procedure DllEntryPoint(dwReason: DWORD);
begin
  case dwReason of
    Dll_Process_Attach: begin
     {If we are getting mapped into a process, then get}
     {a pointer to our process wide memory mapped variable}
        hObjHandle := 0;
        lpHookRec := nil;
        MapFileMemory(sizeof(lpHookRec^));
      end;
    Dll_Process_Detach: begin
     {If we are getting unmapped from a process then, remove}
     {the pointer to our process wide memory mapped variable}
        UnMapFileMemory;
      end;
  end;
end;


exports
  KeyBoardProc name 'KEYBOARDPROC',
  GetHookRecPointer name 'GETHOOKRECPOINTER',
  StartKeyBoardHook name 'STARTKEYBOARDHOOK',
  StopKeyBoardHook name 'STOPKEYBOARDHOOK';

begin
 {Set our Dll's main entry point}
  DLLProc := @DllEntryPoint;
 {Call our Dll's main entry point}
  DllEntryPoint(Dll_Process_Attach);
end.

