unit fMHA_ASI_Options;

{- Designed by Roger Schultz, Ph.D.
   Mental Health Strategic Health Care Group, Informatics Section
   Revision Date: 6/2001
   Description: This form allows user to control the highlight color for ASI entry.

   The color selection is stored in windows registry when project closed. -}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, EsClrCbx, EsGrad;

type
  TfrmASI_Options = class(TForm)
    pnl1: TPanel;
    lbl1: TLabel;
    cbxColorForeground: TEsColorComboBox;
    lbl2: TLabel;
    cbxColorBackground: TEsColorComboBox;
    pnlSample: TPanel;
    cmdOK: TButton;
    cmdCancel: TButton;
    procedure btnOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure cbxColorForegroundChange(Sender: TObject); // Letters used are: C-Close, E-Exit, F-Finish later
                            // S-Save/Verify/Sign it
  private
    { Private declarations }
  public
    { Public declarations }   
  end;

var
  frmASI_Options: TfrmASI_Options;

implementation

uses fMHA_Main, uMHA_MsgDlg;

{$R *.DFM}

var
  initialize : boolean;

procedure TfrmASI_Options.btnOkClick(Sender: TObject);
begin
  MHA_Registry.HighlightForeground := cbxColorForeground.SelectedColor; {TColor}
  MHA_Registry.HighlightBackground := cbxColorBackground.SelectedColor; {TColor}
  MHA_Registry.SaveRegistry;
  Close;
end;

procedure TfrmASI_Options.FormCreate(Sender: TObject);
begin
  initialize := true;
  cbxColorForeground.SelectedColor :=
    MHA_Registry.HighlightForeground;
  cbxColorBackground.SelectedColor :=
    MHA_Registry.HighlightBackground;
  Update;
  initialize := false;
  ShowModal;
end;

procedure TfrmASI_Options.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmASI_Options.cbxColorForegroundChange(Sender: TObject);
begin
  pnlSample.Color := cbxColorBackground.SelectedColor;
  pnlSample.Font.Color := cbxColorForeground.SelectedColor;
  if Initialize then exit;
  if cbxColorBackground.SelectedColor = cbxColorForeground.SelectedColor then
    begin
      MsgDlg('The foreground and background cannot be the same color. The defaults will '+
        'be reinstated.',
        'ASI Highlight Colors', mtInformation, [mbOK], 0);
       // frmASIOptions.Left, frmASIOptions.Top, frmASIOptions.Height, frmASIOptions.Width, 0);
      cbxColorForeground.SelectedColor := clBlack;
      cbxColorBackground.SelectedColor := clYellow;
      pnlSample.Color := cbxColorBackground.SelectedColor;
      pnlSample.Font.Color := cbxColorForeground.SelectedColor;
    end;
  Update;
end;

end.
