unit fMHA_MCMI2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmMCMI2 = class(TForm)
    rgrpQ1: TRadioGroup;
    rgrpQ2: TRadioGroup;
    btnOK: TButton;
    procedure FormActivate(Sender: TObject);
    procedure rgrpQ1Click(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMCMI2: TfrmMCMI2;

implementation

uses
  fMHA_Main, ORfn, uCore, uMHA_SessionControl;

{$R *.DFM}

procedure TfrmMCMI2.FormActivate(Sender: TObject);
begin
  Caption := MHTest.Code + ' Clinician Questions';
  rgrpQ1.Caption := '  Is ' + MixedCase(Piece(Patient.Name, ',', 2))
    + ' ' + MixedCase(Piece(Patient.Name, ',', 1))
    + ' an inpatient or outpatient?  ';
end;


procedure TfrmMCMI2.rgrpQ1Click(Sender: TObject);
begin
  if not (rgrpQ1.ItemIndex = -1) and
    not (rgrpQ2.ItemIndex = -1) then
  begin
    btnOK.Enabled := True;
    btnOK.SetFocus;
  end;
end;

procedure TfrmMCMI2.btnOKClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMCMI2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Escape) then
    Close;
end;

procedure TfrmMCMI2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := ((rgrpQ1.ItemIndex > -1) and (rgrpQ2.ItemIndex > -1));
  if not CanClose then
    ShowMessage('You must answer both questions before continuing.');
end;

procedure TfrmMCMI2.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Q1, Q2: string;
begin
  if rgrpQ1.ItemIndex = 0 then
    Q1 := 'I'
  else
    Q1 := 'O';

  Q2 := IntToStr(rgrpQ2.ItemIndex + 1);

  if Q2 = '10' then
    Q2 := '0';

  PatientSubSession.MCMI2_PatientTraits := Q1 + Q2;
end;

end.

