unit fMHA_TestReport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TfrmReport = class(TForm)
    memReport: TRichEdit;
    pnlButton: TPanel;
    pnlButtons2: TPanel;
    btnSave: TButton;
    btnCopy: TButton;
    btnPrint: TButton;
    btnClose: TButton;
    mnuPopUp: TPopupMenu;
    mnCopyPU: TMenuItem;
    mnuPrintPU: TMenuItem;
    mnuSavePU: TMenuItem;
    procedure btnCloseClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmReport: TfrmReport;

implementation

uses fMHA_Main, Printers, ORFn, uMHA_DM, ORNet, uMHA_MsgDlg;

{$R *.DFM}


procedure TfrmReport.btnCloseClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Close the form
//******************************************************************************
begin
  Close;
end;


procedure TfrmReport.btnPrintClick(Sender: TObject);
//******************************************************************************
// PURPOSE: print test report
//******************************************************************************
var
  presX, presY: Integer;
begin
  with memReport do begin
    Font.Size := 10;
    plaintext := true;
    presX := GetDeviceCaps(printer.handle, LOGPIXELSX);
    presY := GetDeviceCaps(printer.handle, LOGPIXELSY);
    with pagerect do begin
      left := 3 * presX div 4; // .75 inch left margin
      top := presY; // 1 inch top margin
      right := Printer.PageWidth - (3 * presX div 4); // .75 inch right margin
      bottom := Printer.PageHeight - presY; // 1 inch bottom margin
    end;
    Print('Patient Demographics');
    Font.Size := 8;
  end;
end;


procedure TfrmReport.btnCopyClick(Sender: TObject);
//******************************************************************************
// PURPOSE: copy report to clipboard
//******************************************************************************
begin
  with memReport do
  begin
    SelectAll;
    CopyToClipboard;
  end;
  MsgDlg('The report has been copied to the Windows clipboard.' + CRLF + CRLF
    + 'If you like, you may paste it into an open text document.',
    DlgCaption, mtInformation, [mbOK], 0);
end;


procedure TfrmReport.btnSaveClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Save report to rtf file
//******************************************************************************
begin
  with MHA_DataModule.dlgSave do
  begin
    FileName := 'Test Report.rtf';
    Filter := 'Rich text file (*rtf)|*.rtf';
    if Execute then
      memReport.Lines.SaveToFile(FileName);
  end;

end;

procedure TfrmReport.FormCreate(Sender: TObject);
var r: TRect;
begin
  //set form top and height to work area (i.e., desktop size minus task bars)
  SystemParametersInfo(SPI_GetWorkArea, 0, @r, 0);
  BoundsRect := r;
  Top := r.Top;
  Height := r.Bottom - r.Top;

  //set form width to 638 and center it
  Width := 638;
  Left := (r.Right - Width) div 2;

  memReport.Clear;
  memReport.Lines.Assign(frmMain.memTestResults.Lines);

  memReport.SelStart := 0;

end;

procedure TfrmReport.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Escape) then
    Close;
end;

end.

