//---------------------------------------------------------------------------
// ClassExplorer Pro generated source file
// Created by VHASLCCannoD on 6/24/2003, 1:01:51 PM
//---------------------------------------------------------------------------

unit uMHA_BSI;

interface

uses
  SysUtils, Classes;


type
  TBSI = class
  private
    FAnswerTexts: TStringList;
    FGoingToPreviousAnswer: BOOLEAN;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    procedure WriteAnswerText(AItemNumber: integer; AText: string);
    function ReadAnswerText(AItemNumber: integer): string;
    procedure Clear;
    procedure ApplySkipLogic;
    procedure LoadItemNumber;
    function PreviousItemNumber: Integer;
    function ItemIsNotApplicable(AItemNumber: integer): BOOLEAN;
    function ReadAnswer(AItemNumber: integer): string;
    property GoingToPreviousAnswer: BOOLEAN read FGoingToPreviousAnswer write FGoingToPreviousAnswer;
  published
  end; { TBSI }


implementation

uses
  fMHA_Main,
  uMHA_MHInstruments;

destructor TBSI.Destroy;
begin
  FAnswerTexts.Free;
  inherited Destroy;
end;

constructor TBSI.Create;
begin
  inherited Create;
  FAnswerTexts := TStringList.Create;
  Clear;
end;

procedure TBSI.WriteAnswerText(AItemNumber: integer; AText: string);
begin
  FAnswerTexts.Values[IntToStr(AItemNumber)] := AText;
end;

function TBSI.ReadAnswerText(AItemNumber: integer): string;
begin
  Result := FAnswerTexts.Values[IntToStr(AItemNumber)];
end;

procedure TBSI.Clear;
var
  i: integer;
begin
  FAnswerTexts.Clear;
  FGoingToPreviousAnswer := False;
  for i := 1 to 21 do
    FAnswerTexts.Add(IntToStr(i) + '= ');
end;

procedure TBSI.ApplySkipLogic;
const
  Blank = ' ';
var
  i: integer;
begin
  case TestItem.ItemNumber of
    4..5:
      begin
        //This seems radical, but the only time it would really delete
        //answers would be to delete null answers if #4 or #5 were changed
        //from zero.
        //It also would delete #20 and #21 if answered
        //This has to be here (before if statement) in case you're backing up
        TestEngine.ChoicesMade := copy(TestEngine.ChoicesMade, 1, 5);
        for i := 6 to 21 do
          WriteAnswerText(i, Blank);

        if (copy(TestEngine.ChoicesMade, 4, 2) = '00') then
        begin
          for i := 6 to 19 do
          begin
            TestEngine.ChoicesMade := TestEngine.ChoicesMade + Blank;
            WriteAnswerText(i, Blank);
          end; //for i...
          TestItem.ItemNumber := 19;
        end; //if copy...

      end;
    20:
      //Skip #21 if #20 is 0
      if (copy(TestEngine.ChoicesMade, 20, 1) = '0') then
      begin
        TestEngine.ChoicesMade := TestEngine.ChoicesMade + Blank;
        TestItem.ItemNumber := 19;
      end
      else
        //Delete previous null answer, if any
        if (copy(TestEngine.ChoicesMade, 21, 1) = Blank) then
          TestEngine.ChoicesMade := copy(TestEngine.ChoicesMade, 1, 20);
  end; //case
end;

procedure TBSI.LoadItemNumber;
var
  LastAnswer: integer;
begin

  if FGoingToPreviousAnswer then
  begin
    FGoingToPreviousAnswer := False;
    Exit;
  end;

  LastAnswer := Length(Trim(TestEngine.ChoicesMade));

  case LastAnswer of
    5:
      if (copy(TestEngine.ChoicesMade, 4, 2) = '00') then
        TestItem.ItemNumber := 20
      else
        TestItem.ItemNumber := 6;
    20:
      if (copy(TestEngine.ChoicesMade, 20, 1) = '0') then
        TestItem.ItemNumber := 20
      else
        TestItem.ItemNumber := 21;
  else
    TestItem.ItemNumber := LastAnswer + 1;
  end; //case



end;

function TBSI.PreviousItemNumber: Integer;
var
  i: integer;
begin
  i := TestItem.ItemNumber - 1;

  while (i > 1)
    and (Length(Trim(ReadAnswerText(i))) < 2) do
    dec(i);

  Result := i - 1;

end;

function TBSI.ItemIsNotApplicable(AItemNumber: integer): BOOLEAN;
begin
//
//  Result := False;
//
//  if (Length(TestEngine.ChoicesMade) < AItemNumber) then
//    Exit;
//
  Result := (ReadAnswer(AItemNumber) = ' ');

end;

function TBSI.ReadAnswer(AItemNumber: integer): string;
begin
//  if (Length(TestEngine.ChoicesMade) < AItemNumber) then
//  begin
//    Result := '';
//    Exit;
//  end;
  Result := copy(TestEngine.ChoicesMade, AItemNumber, 1);
end;

end.

